
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>Voyager.Actions.TncsFromCoords &#8212; PhaserVoyager 0.0.1 documentation</title>
    <link rel="stylesheet" href="../../../_static/sphinxdoc.css" type="text/css" />
    <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />
    <script type="text/javascript" id="documentation_options" data-url_root="../../../" src="../../../_static/documentation_options.js"></script>
    <script type="text/javascript" src="../../../_static/jquery.js"></script>
    <script type="text/javascript" src="../../../_static/underscore.js"></script>
    <script type="text/javascript" src="../../../_static/doctools.js"></script>
    <script type="text/javascript" src="../../../_static/language_data.js"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../../index.html">PhaserVoyager 0.0.1 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../index.html" accesskey="U">Module code</a> &#187;</li> 
      </ul>
    </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <h1>Source code for Voyager.Actions.TncsFromCoords</h1><div class="highlight"><pre>
<span></span>
<span class="c1">#! /usr/bin/env python</span>
<span class="c1"># -*- coding: utf-8 -*-</span>

<span class="c1">#####################################################################</span>
<span class="c1">#  Copyright and authorship belong to:                              #</span>
<span class="c1">#  @author: Massimo Sammito                                         #</span>
<span class="c1">#  @email: mds83@cam.ac.uk / massimo.sammito@gmail.com              #</span>
<span class="c1">#####################################################################</span>
<span class="c1">#####################################################################</span>
<span class="c1">#                              LICENSE                              #</span>
<span class="c1">#                                                                   #</span>
<span class="c1">#                                                                   #</span>
<span class="c1">#####################################################################</span>

<span class="kn">from</span> <span class="nn">__future__</span> <span class="kn">import</span> <span class="n">print_function</span>
<span class="kn">from</span> <span class="nn">__future__</span> <span class="kn">import</span> <span class="n">division</span>
<span class="kn">from</span> <span class="nn">future.standard_library</span> <span class="kn">import</span> <span class="n">install_aliases</span>
<span class="kn">from</span> <span class="nn">libtbx.phil</span> <span class="kn">import</span> <span class="n">parse</span>

<span class="n">install_aliases</span><span class="p">()</span>

<span class="kn">import</span> <span class="nn">sys</span><span class="o">,</span><span class="nn">os</span><span class="o">,</span><span class="nn">copy</span>
<span class="kn">import</span> <span class="nn">traceback</span>
<span class="kn">import</span> <span class="nn">json</span>
<span class="kn">from</span> <span class="nn">voyager_actions</span> <span class="kn">import</span> <span class="n">Action</span>

<span class="c1">#DISCLAIMER#</span>
<span class="c1">#This class has been generated automatically through strategy_app.py</span>
<span class="c1">#The app does not verify the correctness of the written code</span>
<span class="c1">#Please validate the class before use and manually inspect and correct any error</span>

<div class="viewcode-block" id="TncsFromCoords_exception"><a class="viewcode-back" href="../../../Voyager.Actions.TncsFromCoords.html#Voyager.Actions.TncsFromCoords.TncsFromCoords_exception">[docs]</a><span class="k">class</span> <span class="nc">TncsFromCoords_exception</span><span class="p">(</span><span class="ne">Exception</span><span class="p">):</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">msg</span><span class="p">):</span>
        <span class="nb">super</span><span class="p">(</span><span class="n">TncsFromCoords_exception</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span><span class="o">.</span><span class="fm">__init__</span><span class="p">(</span><span class="n">msg</span><span class="p">)</span></div>
        
<div class="viewcode-block" id="TncsFromCoords"><a class="viewcode-back" href="../../../Voyager.Actions.TncsFromCoords.html#Voyager.Actions.TncsFromCoords.TncsFromCoords">[docs]</a><span class="k">class</span> <span class="nc">TncsFromCoords</span><span class="p">(</span><span class="n">Action</span><span class="p">):</span>
    <span class="n">info_dag_nodes</span> <span class="o">=</span> <span class="p">{</span><span class="s2">&quot;hkl_input&quot;</span><span class="p">:</span><span class="s2">&quot;*&quot;</span><span class="p">,</span><span class="s2">&quot;hkl_output&quot;</span><span class="p">:</span><span class="s2">&quot;1&quot;</span><span class="p">,</span><span class="s2">&quot;model_input&quot;</span><span class="p">:</span><span class="s2">&quot;1&quot;</span><span class="p">,</span><span class="s2">&quot;model_output&quot;</span><span class="p">:</span><span class="s2">&quot;0&quot;</span><span class="p">,</span><span class="s2">&quot;occurrences&quot;</span><span class="p">:</span><span class="s2">&quot;1&quot;</span><span class="p">}</span>
    <span class="n">rule</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot;[[&quot;TNCS&quot;], [&quot;IsoStructureSearch&quot;]]&quot;&quot;&quot;</span>
    <span class="n">phasertngphil</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot;&quot;&quot;&quot;</span>
    <span class="n">masterphil</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot;voyager.TncsFromCoords {</span>
<span class="s2">angle = 15</span>
<span class="s2">  .type = float(value_min=0)</span>
<span class="s2">  .expert_level = 0</span>
<span class="s2">  .optional = True</span>
<span class="s2">  .short_caption = Angle degrees</span>
<span class="s2">  .help = Angle in degrees of the maximum angular difference threshold allowed between two copies</span>

<span class="s2">sequence_identity = 90</span>
<span class="s2">  .type = float(value_min=0, value_max=100)</span>
<span class="s2">  .expert_level = 0</span>
<span class="s2">  .optional = True</span>
<span class="s2">  .short_caption = Sequence identity</span>
<span class="s2">  .help = Percentage of sequence identity between two molecules to consider them two copies of the same thing</span>
<span class="s2">  </span>
<span class="s2">tolerance = 0.05</span>
<span class="s2">  .type = float(value_min=0, value_max=5)</span>
<span class="s2">  .expert_level = 0</span>
<span class="s2">  .optional = True</span>
<span class="s2">  .short_caption = Difference tolerance</span>
<span class="s2">  .help = Difference tolerance for the tncs vector</span>
<span class="s2">}&quot;&quot;&quot;</span>
    <span class="n">helpstring</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot; This action helps to identify TNCS from a coordinate file (pdb). If Xtricorder has been perfromed and thus phasertng tncs mode has been executed, the action will select the correct tncs comparing it with the coordinates.&quot;&quot;&quot;</span>

    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">strategy</span><span class="p">,</span> <span class="n">current_phil_keywords</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">name</span> <span class="o">=</span> <span class="s1">&#39;TncsFromCoords&#39;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">argsparse</span> <span class="o">=</span> <span class="n">strategy</span><span class="o">.</span><span class="n">arguments</span>
        <span class="nb">super</span><span class="p">(</span><span class="n">TncsFromCoords</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span><span class="o">.</span><span class="fm">__init__</span><span class="p">(</span><span class="n">strategy</span><span class="p">,</span> <span class="n">current_phil_keywords</span><span class="p">)</span>

<div class="viewcode-block" id="TncsFromCoords.check_imports"><a class="viewcode-back" href="../../../Voyager.Actions.TncsFromCoords.html#Voyager.Actions.TncsFromCoords.TncsFromCoords.check_imports">[docs]</a>    <span class="k">def</span> <span class="nf">check_imports</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">b</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">test</span><span class="p">()</span>
        <span class="k">except</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">NotImplementedError</span><span class="p">(</span><span class="s2">&quot;test() method has not been implemented!&quot;</span><span class="p">)</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">c</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">help</span><span class="p">()</span>
        <span class="k">except</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">NotImplementedError</span><span class="p">(</span><span class="s2">&quot;help() method has not been implemented!&quot;</span><span class="p">)</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">d</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">get_name</span><span class="p">()</span>
        <span class="k">except</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">NotImplementedError</span><span class="p">(</span><span class="s2">&quot;get_name() method has not been implemented!&quot;</span><span class="p">)</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">iotbx</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;iotbx&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">numpy</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;numpy&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">tncs</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;mmtbx.ncs&quot;</span><span class="p">,</span> <span class="n">fromlist</span><span class="o">=</span><span class="p">[</span><span class="s2">&quot;tncs&quot;</span><span class="p">])</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">system_utility</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;system_utility&quot;</span><span class="p">)</span>

        <span class="k">return</span> <span class="kc">True</span></div>

<div class="viewcode-block" id="TncsFromCoords.test"><a class="viewcode-back" href="../../../Voyager.Actions.TncsFromCoords.html#Voyager.Actions.TncsFromCoords.TncsFromCoords.test">[docs]</a>    <span class="k">def</span> <span class="nf">test</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="c1">#TODO: perform a complete self contained test</span>
        <span class="k">pass</span></div>
    
<div class="viewcode-block" id="TncsFromCoords.help"><a class="viewcode-back" href="../../../Voyager.Actions.TncsFromCoords.html#Voyager.Actions.TncsFromCoords.TncsFromCoords.help">[docs]</a>    <span class="k">def</span> <span class="nf">help</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">helpstring</span></div>
    
<div class="viewcode-block" id="TncsFromCoords.get_name"><a class="viewcode-back" href="../../../Voyager.Actions.TncsFromCoords.html#Voyager.Actions.TncsFromCoords.TncsFromCoords.get_name">[docs]</a>    <span class="k">def</span> <span class="nf">get_name</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">name</span></div>
    
<div class="viewcode-block" id="TncsFromCoords.run"><a class="viewcode-back" href="../../../Voyager.Actions.TncsFromCoords.html#Voyager.Actions.TncsFromCoords.TncsFromCoords.run">[docs]</a>    <span class="k">def</span> <span class="nf">run</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">notify_start</span><span class="p">()</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s2">&quot;logger&quot;</span><span class="p">):</span> <span class="k">raise</span> <span class="n">TncsFromCoords_exception</span><span class="p">(</span><span class="s2">&quot;Logger File has not been set. Please call &#39;set_logger_file&#39; method before run&quot;</span><span class="p">)</span>
        <span class="n">user_phil</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">program_master_phil</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">python_object</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">argsparse</span><span class="p">)</span>
        <span class="n">diffuser_phil</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">program_master_phil</span><span class="o">.</span><span class="n">fetch_diff</span><span class="p">(</span><span class="n">source</span><span class="o">=</span><span class="n">user_phil</span><span class="p">)</span>
        <span class="n">action_phil</span> <span class="o">=</span> <span class="n">parse</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">current_phil_keywords</span><span class="p">)</span>
        <span class="n">diffaction_phil</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">program_master_phil</span><span class="o">.</span><span class="n">fetch_diff</span><span class="p">(</span><span class="n">source</span><span class="o">=</span><span class="n">action_phil</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">argsparse</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">program_master_phil</span><span class="o">.</span><span class="n">fetch</span><span class="p">(</span><span class="n">sources</span><span class="o">=</span><span class="p">[</span><span class="n">diffaction_phil</span><span class="p">,</span> <span class="n">diffuser_phil</span><span class="p">])</span><span class="o">.</span><span class="n">extract</span><span class="p">()</span>
        <span class="n">nodetncs</span><span class="p">,</span> <span class="n">nodemodel</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">check_tncs_from_coords</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">argsparse</span><span class="p">)</span>
        <span class="n">output</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">select_the_space_group</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">argsparse</span><span class="p">,</span> <span class="n">nodetncs</span><span class="p">,</span> <span class="n">nodemodel</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">notify_end</span><span class="p">()</span>
        <span class="k">return</span> <span class="n">output</span></div>

<div class="viewcode-block" id="TncsFromCoords.check_tncs_from_coords"><a class="viewcode-back" href="../../../Voyager.Actions.TncsFromCoords.html#Voyager.Actions.TncsFromCoords.TncsFromCoords.check_tncs_from_coords">[docs]</a>    <span class="k">def</span> <span class="nf">check_tncs_from_coords</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">argsparse</span><span class="p">):</span>
        <span class="n">root</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">initial_dag_nodes</span>
        <span class="n">modelid</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="n">nodemodel</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="k">if</span> <span class="n">root</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">raise</span> <span class="n">TncsFromCoords_exception</span><span class="p">(</span><span class="s2">&quot;No model in the Phaser Dag graph!&quot;</span><span class="p">)</span>
        <span class="k">elif</span> <span class="ow">not</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">root</span><span class="p">,</span> <span class="nb">list</span><span class="p">):</span>
            <span class="n">root</span> <span class="o">=</span> <span class="p">[</span><span class="n">root</span><span class="p">]</span>

        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">root</span><span class="p">,</span> <span class="nb">list</span><span class="p">):</span>
            <span class="n">nodemodel</span> <span class="o">=</span> <span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">get_most_recent_node_with_pdb_model</span><span class="p">(</span><span class="n">t</span><span class="p">,</span> <span class="n">label</span><span class="o">=</span><span class="s2">&quot;isostructure&quot;</span><span class="p">)</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">root</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span>
            <span class="k">if</span> <span class="n">nodemodel</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                <span class="n">modelid</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">nodemodel</span><span class="p">)[</span><span class="s2">&quot;model_identifier&quot;</span><span class="p">]</span>

        <span class="k">if</span> <span class="n">modelid</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span> <span class="k">raise</span> <span class="n">TncsFromCoords_exception</span><span class="p">(</span><span class="s2">&quot;No model in the Phaser Dag graph!&quot;</span><span class="p">)</span>

        <span class="n">files</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">schedule_extract_from_db</span><span class="p">(</span><span class="n">modelid</span><span class="p">,</span> <span class="n">in_memory</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
        <span class="n">pdb</span> <span class="o">=</span> <span class="n">files</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
    
        <span class="n">xtal</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">iotbx</span><span class="o">.</span><span class="n">pdb</span><span class="o">.</span><span class="n">input</span><span class="p">(</span><span class="n">file_name</span><span class="o">=</span><span class="n">pdb</span><span class="p">)</span>
        <span class="n">hroot</span> <span class="o">=</span> <span class="n">xtal</span><span class="o">.</span><span class="n">construct_hierarchy</span><span class="p">()</span>
        <span class="n">xtalsym</span> <span class="o">=</span> <span class="n">xtal</span><span class="o">.</span><span class="n">crystal_symmetry</span><span class="p">()</span>
        <span class="n">firstchain</span> <span class="o">=</span> <span class="n">hroot</span><span class="o">.</span><span class="n">models</span><span class="p">()[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">chains</span><span class="p">()[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">id</span>
        <span class="n">angle</span> <span class="o">=</span> <span class="n">argsparse</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">TncsFromCoords</span><span class="o">.</span><span class="n">angle</span>
        <span class="n">seqid</span> <span class="o">=</span> <span class="n">argsparse</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">TncsFromCoords</span><span class="o">.</span><span class="n">sequence_identity</span>
        <span class="n">tolerance</span> <span class="o">=</span> <span class="n">argsparse</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">TncsFromCoords</span><span class="o">.</span><span class="n">tolerance</span>
    
        <span class="n">tncsinpdb</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">tncs</span><span class="o">.</span><span class="n">tncs</span><span class="o">.</span><span class="n">groups</span><span class="p">(</span><span class="n">pdb_hierarchy</span><span class="o">=</span><span class="n">hroot</span><span class="p">,</span> <span class="n">crystal_symmetry</span><span class="o">=</span><span class="n">xtalsym</span><span class="p">,</span> <span class="n">angular_difference_threshold_deg</span><span class="o">=</span><span class="n">angle</span><span class="p">,</span> <span class="n">sequence_identity_threshold</span><span class="o">=</span><span class="n">seqid</span><span class="p">)</span>
        <span class="n">order</span> <span class="o">=</span> <span class="n">tncsinpdb</span><span class="o">.</span><span class="n">tncsresults</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
        <span class="n">vectors</span> <span class="o">=</span> <span class="n">tncsinpdb</span><span class="o">.</span><span class="n">tncsresults</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span>
        <span class="k">for</span> <span class="n">file</span> <span class="ow">in</span> <span class="n">files</span><span class="p">:</span> <span class="n">os</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="n">file</span><span class="p">)</span>

        <span class="n">tncsnodes</span> <span class="o">=</span> <span class="p">[</span><span class="n">x</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">get_all_nodes_with_hkl_data</span><span class="p">(</span><span class="n">t</span><span class="p">,</span> <span class="n">label</span><span class="o">=</span><span class="s2">&quot;tncs&quot;</span><span class="p">)</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">root</span><span class="p">]</span>

        <span class="k">for</span> <span class="n">infos</span> <span class="ow">in</span> <span class="n">vectors</span><span class="p">:</span>
            <span class="n">vector1</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">numpy</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">infos</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
            <span class="n">vector2</span> <span class="o">=</span> <span class="o">-</span><span class="mi">1</span><span class="o">*</span><span class="n">vector1</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;ORDER: &quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">order</span><span class="p">)</span><span class="o">+</span><span class="s2">&quot; VECTOR: &quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">vector1</span><span class="p">)</span><span class="o">+</span><span class="s2">&quot; &quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">vector2</span><span class="p">))</span>
            <span class="k">for</span> <span class="n">r</span> <span class="ow">in</span> <span class="n">tncsnodes</span><span class="p">:</span>
                <span class="n">l</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">r</span><span class="p">)</span>

                <span class="k">try</span><span class="p">:</span>
                    <span class="n">difference1</span><span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">numpy</span><span class="o">.</span><span class="n">abs</span><span class="p">(</span><span class="n">vector1</span><span class="o">-</span><span class="bp">self</span><span class="o">.</span><span class="n">numpy</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">l</span><span class="p">[</span><span class="s2">&quot;data&quot;</span><span class="p">][</span><span class="mi">1</span><span class="p">]))</span>
                    <span class="c1">#print(&quot;Difference: &quot;+str(difference1)+&quot; &quot;+str(tolerance)+&quot; &quot;+str(type(tolerance))+&quot; &quot;+str(difference1 &lt;= tolerance)+&quot; &quot;+str(self.numpy.all(difference1 &lt;= tolerance)))</span>
                    <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">numpy</span><span class="o">.</span><span class="n">all</span><span class="p">(</span><span class="n">difference1</span> <span class="o">&lt;=</span> <span class="n">tolerance</span><span class="p">):</span>
                        <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;TNCS confirmed by data and coordinates: ORDER: &quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">order</span><span class="p">)</span><span class="o">+</span><span class="s2">&quot; VECTOR: &quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">vector1</span><span class="p">))</span>
                        <span class="c1">#s = [final[1] for final in path_from_root if r in final[0]]</span>
                        <span class="n">s</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">get_all_leaves_from</span><span class="p">(</span><span class="n">r</span><span class="p">)</span>
                        <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">s</span><span class="p">)</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span> <span class="k">return</span> <span class="p">[</span><span class="n">r</span><span class="p">],</span> <span class="n">nodemodel</span>
                        <span class="k">else</span><span class="p">:</span> <span class="k">return</span> <span class="n">s</span><span class="p">,</span> <span class="n">nodemodel</span>
                    <span class="n">difference2</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">numpy</span><span class="o">.</span><span class="n">abs</span><span class="p">(</span><span class="n">vector2</span> <span class="o">-</span> <span class="bp">self</span><span class="o">.</span><span class="n">numpy</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">l</span><span class="p">[</span><span class="s2">&quot;data&quot;</span><span class="p">][</span><span class="mi">1</span><span class="p">]))</span>
                    <span class="c1">#print(&quot;Difference&quot;, difference2, tolerance, type(tolerance), difference2 &lt;= tolerance, self.numpy.all(difference2 &lt;= tolerance))</span>
                    <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">numpy</span><span class="o">.</span><span class="n">all</span><span class="p">(</span><span class="n">difference2</span> <span class="o">&lt;=</span> <span class="n">tolerance</span><span class="p">):</span>
                        <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;TNCS confirmed by data and coordinates: ORDER: &quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">order</span><span class="p">)</span><span class="o">+</span><span class="s2">&quot; VECTOR: &quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">vector2</span><span class="p">))</span>
                        <span class="n">s</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">get_all_leaves_from</span><span class="p">(</span><span class="n">r</span><span class="p">)</span>
                        <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">s</span><span class="p">)</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span> <span class="k">return</span> <span class="p">[</span><span class="n">r</span><span class="p">],</span> <span class="n">nodemodel</span>
                        <span class="k">else</span><span class="p">:</span><span class="k">return</span> <span class="n">s</span><span class="p">,</span> <span class="n">nodemodel</span>
                <span class="k">except</span><span class="p">:</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">error</span><span class="p">(</span><span class="n">sys</span><span class="o">.</span><span class="n">exc_info</span><span class="p">())</span>
                    <span class="n">traceback</span><span class="o">.</span><span class="n">print_exc</span><span class="p">(</span><span class="n">file</span><span class="o">=</span><span class="n">sys</span><span class="o">.</span><span class="n">stdout</span><span class="p">)</span>
    
        <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;TNCS not found or not confirmed by coordinates&quot;</span><span class="p">)</span>
        <span class="k">for</span> <span class="n">r</span> <span class="ow">in</span> <span class="n">tncsnodes</span><span class="p">:</span>
            <span class="n">l</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">r</span><span class="p">)</span>
            <span class="k">try</span><span class="p">:</span>
                <span class="n">vec</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">numpy</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">l</span><span class="p">[</span><span class="s2">&quot;data&quot;</span><span class="p">][</span><span class="mi">1</span><span class="p">])</span>
                <span class="n">orn</span> <span class="o">=</span> <span class="n">l</span><span class="p">[</span><span class="s2">&quot;data&quot;</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span>
                <span class="k">if</span> <span class="n">orn</span> <span class="o">==</span> <span class="mi">1</span><span class="p">:</span>
                    <span class="n">s</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">get_all_leaves_from</span><span class="p">(</span><span class="n">r</span><span class="p">)</span>
                    <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">s</span><span class="p">)</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span><span class="k">return</span> <span class="p">[</span><span class="n">r</span><span class="p">],</span> <span class="n">nodemodel</span>
                    <span class="k">else</span><span class="p">:</span><span class="k">return</span> <span class="n">s</span><span class="p">,</span> <span class="n">nodemodel</span>
            <span class="k">except</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">error</span><span class="p">(</span><span class="n">sys</span><span class="o">.</span><span class="n">exc_info</span><span class="p">())</span>
                <span class="n">traceback</span><span class="o">.</span><span class="n">print_exc</span><span class="p">(</span><span class="n">file</span><span class="o">=</span><span class="n">sys</span><span class="o">.</span><span class="n">stdout</span><span class="p">)</span></div>

<div class="viewcode-block" id="TncsFromCoords.select_the_space_group"><a class="viewcode-back" href="../../../Voyager.Actions.TncsFromCoords.html#Voyager.Actions.TncsFromCoords.TncsFromCoords.select_the_space_group">[docs]</a>    <span class="k">def</span> <span class="nf">select_the_space_group</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">argsparse</span><span class="p">,</span> <span class="n">nodetncs</span><span class="p">,</span> <span class="n">nodemodel</span><span class="p">):</span>
        <span class="n">nm</span> <span class="o">=</span> <span class="p">[</span><span class="n">x</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">predecessors</span><span class="p">(</span><span class="n">nodemodel</span><span class="p">)</span> <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">x</span><span class="p">)[</span><span class="s2">&quot;type&quot;</span><span class="p">]</span> <span class="o">==</span> <span class="s2">&quot;modelcontainer&quot;</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span>
        <span class="n">pdbid</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">nm</span><span class="p">)[</span><span class="s2">&quot;data&quot;</span><span class="p">][</span><span class="s2">&quot;foundpdb&quot;</span><span class="p">]</span><span class="o">.</span><span class="n">keys</span><span class="p">()[</span><span class="mi">0</span><span class="p">]</span>

        <span class="n">z</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">system_utility</span><span class="o">.</span><span class="n">request_url</span><span class="p">(</span><span class="s2">&quot;https://www.ebi.ac.uk/pdbe/api/pdb/entry/experiment/&quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">pdbid</span><span class="o">.</span><span class="n">lower</span><span class="p">()),</span> <span class="s2">&quot;www.ebi.ac.uk&quot;</span><span class="p">)</span>
        <span class="n">infol</span> <span class="o">=</span> <span class="n">json</span><span class="o">.</span><span class="n">loads</span><span class="p">(</span><span class="n">z</span><span class="p">)</span>
        <span class="n">spacegroup</span> <span class="o">=</span> <span class="n">infol</span><span class="p">[</span><span class="n">pdbid</span><span class="o">.</span><span class="n">lower</span><span class="p">()][</span><span class="mi">0</span><span class="p">][</span><span class="s2">&quot;spacegroup&quot;</span><span class="p">]</span>

        <span class="n">nodesgx</span> <span class="o">=</span> <span class="p">[</span><span class="n">x</span> <span class="k">for</span> <span class="n">t</span> <span class="ow">in</span> <span class="n">nodetncs</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">get_all_nodes_with_hkl_data</span><span class="p">(</span><span class="n">t</span><span class="p">,</span> <span class="n">label</span><span class="o">=</span><span class="n">spacegroup</span><span class="p">,</span> <span class="n">label_is_spacegroup</span><span class="o">=</span><span class="kc">True</span><span class="p">)]</span>
        <span class="n">output</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">for</span> <span class="n">ngx</span> <span class="ow">in</span> <span class="n">nodesgx</span><span class="p">:</span>
            <span class="n">s</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">get_all_leaves_from</span><span class="p">(</span><span class="n">ngx</span><span class="p">)</span>
            <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">s</span><span class="p">)</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span>
                <span class="n">output</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">ngx</span><span class="p">)</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">output</span> <span class="o">+=</span> <span class="n">s</span>

        <span class="k">return</span> <span class="n">output</span></div></div>
</pre></div>

          </div>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../../index.html">PhaserVoyager 0.0.1 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../index.html" >Module code</a> &#187;</li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2020, Massimo D. Sammito.
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 1.8.5.
    </div>
  </body>
</html>